<?php
// tòmò web analytics
// Copyright since 2011 by Yves Goergen
// Website: http://unclassified.de/go/tomo
// Licence: GNU General Public License (GPL) Version 3
// Encoding: UTF-8 (without BOM) (auto-detect: °°°°°)
//
// This file is derived from:
// UNB Components
// Copyright since 2007 by Yves Goergen
// Website: http://unclassified.de/go/unb2
// Licence: GNU General Public License (GPL) Version 3
//
// This file contains the UNB locale en-US class.

if (!class_exists('UnbLocale', false)) require_once dirname(__FILE__) . '/../locale.class.php';

// en-US locale class.
//
class UnbLocale_en_US extends UnbLocale
{
	// Locale code.
	protected $code = 'en-US';

	// Native locale name.
	protected $nativeName = 'English (US)';

	// Locale importance for its language, used to sort known locales when only a language is requested.
	// This should be roughly the number of people affected by the locale, divided by 1000.
	protected $importance = 251000;   // Source: http://en.wikipedia.org/wiki/English_language#Countries_in_order_of_total_speakers

	// Starting quotation mark.
	protected $quoteStart = '“';

	// Ending quotation mark.
	protected $quoteEnd = '”';

	// Colon.
	protected $colon = ':';

	// The text dictionary.
	protected $dict = array(
		'exception:BadMethodCallException' => 'Bad method call',
		'exception:Exception' => 'Error',
		'exception:InvalidArgumentException' => 'Invalid argument',
		'exception:LengthException' => 'Length error',

		#'error:2' => 'Page name is too long.',
		#'error:40' => 'User name {name} is unknown.',

		'error:password security.too short' => 'At least 6 characters required.',
		'error:password security.equals username' => 'Password must not be equal to the username.',
		'error:password security.contains username' => 'Password must not contain the username.',
		'error:password security.non ascii' => 'Only ASCII characters are allowed.',
		'error:password security.character classes' => 'At least 2 character classes out of numbers, lowercase, uppercase characters and other symbols required.',
		'error:password security.repeated character' => 'No character may be repeated 3 times or more.',
		'error:password security.simple sequences' => 'Simple sequences like 123 or abc are not allowed.',
		'error:password security.different characters' => 'At least 4 different characters must be used.',

		'empty' => 'empty',
		'unit:bytes' => '{#} bytes',
		'unit:bytes#1' => 'one byte',
		'format:decimal' => '.',

		'active' => 'active',
		'add field' => 'add field',
		'admin opt-out cookie' => 'admin opt-out cookie',
		'admin opt-out cookie.do set' => 'set opt-out cookie',
		'admin opt-out cookie.do unset' => 'delete opt-out cookie',
		'admin opt-out cookie.set' => 'The admin opt-out cookie is set and valid. You can move freely on your website without being tracked.',
		'admin opt-out cookie.unset' => 'The admin opt-out cookie is not currently set or invalid. All of your own actions on this website will be tracked regularly.',
		'app info' => 'App info',
		'available screen' => 'available',
		'bounce' => 'bounce',
		'campaign' => 'campaign',
		'client' => 'client',
		'column' => 'column',
		'current language' => 'current language',
		'custom pageview variable' => 'Custom variable for the pageview',
		'custom pageview variable created' => 'Pageview variable {name} created in the database.',
		'custom pageview variable create error' => 'Error adding pageview variable {name} into the database.',
		'custom session variable' => 'Custom variable for the session',
		'custom session variable created' => 'Session variable {name} created in the database.',
		'custom session variable create error' => 'Error adding session variable {name} into the database.',
		'custom variables' => 'Custom variables',
		'custom visitor variable' => 'Custom variable for the visitor',
		'custom visitor variable created' => 'Visitor variable {name} created in the database.',
		'custom visitor variable create error' => 'Error adding visitor variable {name} into the database.',
		'customvar.scope' => 'scope',
		'customvar.name' => 'name',
		'customvar.type' => 'type',
		'customvar.notes' => 'notes',
		'customvar.create in database' => 'create in the database',
		'customvar.in database not configured' => 'in the database but not configured',
		'customvar.invalid name' => 'invalid variable name!',
		'customvar.none' => 'No variables configured or in the database.',
		'customvar.ok' => 'OK',
		'data files status' => 'Data files status',
		'direct entry' => 'direct entry',
		'direct entry or bookmark' => 'direct entry or bookmark',
		'disabled' => 'disabled',
		'download' => 'download',
		'enter access password' => 'Enter the access password',
		'entry page' => 'entry page',
		'exit page' => 'exit page',
		'field' => 'field',
		'file size' => 'file size',
		'filter' => 'filter',
		'first entry' => 'first entry',
		'geoip.country-level database' => 'country-level database',
		'geoip.city-level database' => 'city-level database',
		'image zoom' => 'image zoom',
		'info and management' => 'Info and management',
		'limit visitor log.1' => 'Limit visitor log to',
		'limit visitor log.2' => 'records',
		'loading canceled' => 'loading canceled',
		'local' => 'local',
		'location' => 'location',
		'location/duration' => 'location/duration',
		'login' => 'log in',
		'login.temporary' => 'temporary',
		'login.temporary~' => 'Stores the login only for this session instead of a longer time.',
		'logout' => 'log out',
		'mobile device' => 'mobile device',
		'navigated back' => 'navigated back',
		'navigated forward' => 'navigated forward',
		'no filter set' => 'no filter set',
		'no rdns' => 'no RDNS',
		'no search terms available' => 'no search terms available',
		'not' => 'not',
		'not present' => 'not present',
		'operation' => 'operation',
		'options' => 'options',
		'outlink' => 'outgoing link',
		'overview link' => 'Back to overview page',
		'page' => 'page',
		'page load time' => 'page load time',
		'pageview' => 'pageview',
		'pageviews' => 'pageviews',
		'public suffix list' => 'public suffix list',
		'query caption' => 'tòmò query',
		'query returned no data' => 'This query does not return any data.',
		'query view' => 'query view',
		'query view intro' => 'Select a query from the list at the top right to view the report.',
		'referring website' => 'referring website',
		'reloaded page' => 'reloaded page',
		'remove column' => 'remove column',
		'returning visitor' => 'returning visitor',
		'reverse visitor log order' => 'Reverse order to show newer pageviews first',
		'revisited page' => 'revisited page',
		'screen size' => 'screen size',
		'search engine' => 'search engine',
		'search image' => 'image found',
		'section expand' => 'expanded section',
		'select query' => 'select query',
		'session' => 'session',
		'session continuation' => 'continuation of a previous visit',
		'session hit count' => '{#} views',
		'session hit count#1' => 'one view',
		'session page count' => 'of {#} pages',
		'session page count#1' => 'of one page',
		'session time over' => 'over',
		'sessions' => 'sessions',
		'set' => 'set',
		'site search' => 'site search',
		'source/action' => 'source/action',
		'summary' => 'summary',
		'summary.unique visitors' => 'unique visitors',
		'summary.first' => 'first',
		'summary.last' => 'last',
		'texts' => 'texts',
		'time' => 'time',
		'time since page load' => 'time since loading the page',
		'tomo database' => 'tòmò database',
		'tomo viewer title' => 'tòmò viewer',
		'tomo viewer intro' => 'Choose a view:',
		'unknown' => 'unknown',
		'update' => 'update',
		'updated on date' => 'updated on {date}',
		'value' => 'value',
		'version' => 'version',
		'view button' => 'view',
		'viewport size' => 'viewport size',
		'visitors' => 'visitors',
		'visitor log' => 'visitor log',
		'visitor log caption' => 'tòmò visitor log',
		'warning.access password unset' => 'The access password is unset. An attacker could log into this application with no password. You should set this password as soon as possible in the configuration file.',
		'warning.access password default' => 'The access password is still set to the default value. An attacker could easily guess it and log into this application. You should change this password as soon as possible in the configuration file.',
		'warning.opt-out password unset' => 'The opt-out password is unset. Any visitor of your website could create their own admin opt-out cookie to escape tracking. You should set this password in the configuration file.',
		'warning.opt-out password default' => 'The opt-out password is still set to the default value. Any visitor of your website could easily guess it and create their own admin opt-out cookie to escape tracking. You should change this password in the configuration file.',

		'column:ActionData' => 'Action data',
		'column:ActionId' => 'Action ID',
		'column:ActionTime' => 'Action time',
		'column:ActionType' => 'Action type',
		'column:ActionUrl' => 'Action URL',
		'column:ActivityTimespan' => 'Activity timespan',
		'column:AdBlock' => 'Ad blocker',
		'column:Browser' => 'Browser',
		'column:Campaign' => 'Campaign',
		'column:CampaignRedirect' => 'Campaign redirection',
		'column:City' => 'City',
		'column:Cookies' => 'Cookies',
		'column:CountryCode' => 'Country code',
		'column:DNT' => 'DNT',
		'column:Domain' => 'Domain',
		'column:EntryPage' => 'Entry page',
		'column:ExitPage' => 'Exit page',
		'column:Flash' => 'Flash',
		'column:IPAddress' => 'IP address',
		'column:IPVersion' => 'IP version',
		'column:Java' => 'Java',
		'column:JavaScript' => 'JavaScript',
		'column:JavaScriptData' => 'JavaScript data',
		'column:Language' => 'Language',
		'column:Lat' => 'Latitude',
		'column:Lng' => 'Longitude',
		'column:Mobile' => 'Mobile device',
		'column:NewVisitor' => 'New visitor',
		'column:OperatingSystem' => 'Operating system',
		'column:OriginalPageviewId' => 'Original pageview ID',
		'column:PageLoadTime' => 'Page load time',
		'column:PageTitle' => 'Page title',
		'column:PageLanguage' => 'Page language',
		'column:PageviewId' => 'Pageview ID',
		'column:PageviewTime' => 'Pageview time',
		'column:PageviewUpdateTime' => 'Pageview update time',
		'column:Prerender' => 'Prerender',
		'column:Provider' => 'Provider',
		'column:Quicktime' => 'Quicktime',
		'column:ReferrerHost' => 'Referrer host',
		'column:ReferrerUrlPath' => 'Referrer URL path',
		'column:ReferrerSsl' => 'Referrer SSL',
		'column:Region' => 'Region',
		'column:ScreenAvailHeight' => 'Desktop height',
		'column:ScreenAvailWidth' => 'Desktop width',
		'column:ScreenColors' => 'Color depth',
		'column:ScreenHeight' => 'Screen height',
		'column:ScreenWidth' => 'Screen width',
		'column:SearchEngine' => 'Search engine',
		'column:SearchImageUrl' => 'Search image URL',
		'column:SearchKeywords' => 'Search keywords',
		'column:SearchResultPage' => 'Search result page',
		'column:SessionDuration' => 'Session duration',
		'column:SessionId' => 'Session ID',
		'column:SessionStartTime' => 'Session start time',
		'column:SessionUpdateTime' => 'Session update time',
		'column:Silverlight' => 'Silverlight',
		'column:Ssl' => 'SSL',
		'column:UrlHash' => 'URL hash',
		'column:UrlPath' => 'URL path',
		'column:UrlQuery' => 'URL query parameters',
		'column:UtcOffset' => 'UTC offset',
		'column:ViewportHeight' => 'Page height',
		'column:ViewportWidth' => 'Page width',
		'column:VisitorId' => 'Visitor ID',
		'column:WindowsMedia' => 'Windows Media',
		
		'coldesc:ActionData' => 'Additional data of the action that was performed',
		'coldesc:ActionId' => 'Internal ID of the action that was performed',
		'coldesc:ActionTime' => 'Time when the action was performed',
		'coldesc:ActionType' => 'Internal type code of the action that was performed',
		'coldesc:ActionUrl' => 'URL of the action that was performed',
		'coldesc:ActivityTimespan' => 'Duration of user activity on the page, in seconds',
		'coldesc:AdBlock' => 'Indicates whether the visitor has installed an ad blocker',
		'coldesc:Browser' => 'Browser name and version',
		'coldesc:Campaign' => 'Campaign name',
		'coldesc:CampaignRedirect' => 'Indicates whether this pageview was redirecting away from a campaign URL',
		'coldesc:City' => 'City where the visitor has been located',
		'coldesc:Cookies' => 'Indicates whether the browser supports cookies',
		'coldesc:CountryCode' => 'Two-letter code of the country where the visitor has been located',
		'coldesc:DNT' => 'Indicates whether the browser has set the Do-Not-Track header',
		'coldesc:Domain' => 'Domain of the viewed page',
		'coldesc:EntryPage' => 'Indicates whether the pageview was the first page of the session',
		'coldesc:ExitPage' => 'Indicates whether the pageview was the last page of the session',
		'coldesc:Flash' => 'Indicates whether the browser supports the Flash plug-in',
		'coldesc:IPAddress' => 'IP address of the visitor, or a hash value of it',
		'coldesc:IPVersion' => 'IP version of the visitor (4 or 6)',
		'coldesc:Java' => 'Indicates whether the browser supports the Java plug-in',
		'coldesc:JavaScript' => 'Indicates whether the browser supports JavaScript',
		'coldesc:JavaScriptData' => 'Indicates whether the browser data was collected with JavaScript',
		'coldesc:Language' => 'Ordered language codes preferred by the browser, comma-separated',
		'coldesc:Lat' => 'Latitude of the approximate geolocation',
		'coldesc:Lng' => 'Longitude of the approximate geolocation',
		'coldesc:Mobile' => 'Indicates whether the client is a handheld mobile device',
		'coldesc:NewVisitor' => 'Indicates whether the visitor is new to this site',
		'coldesc:OperatingSystem' => 'Operating system name and version',
		'coldesc:OriginalPageviewId' => 'Internal ID of the original pageview',
		'coldesc:PageLoadTime' => 'Time it took for the page to load, in milliseconds',
		'coldesc:PageTitle' => 'Title of the page being viewed',
		'coldesc:PageLanguage' => 'Language in which the page was displayed',
		'coldesc:PageviewId' => 'Internal ID of the pageview',
		'coldesc:PageviewTime' => 'Time when the pageview was started',
		'coldesc:PageviewUpdateTime' => 'Time when the pageview was last updated',
		'coldesc:Prerender' => 'Indicates whether the page was only retrieved for pre-rendering, but was never shown on screen',
		'coldesc:Provider' => 'Name of the visitor’s internet provider',
		'coldesc:Quicktime' => 'Indicates whether the browser supports the Quicktime plug-in',
		'coldesc:ReferrerHost' => 'URL host of the previous page',
		'coldesc:ReferrerUrlPath' => 'URL path of the previous page',
		'coldesc:ReferrerSsl' => 'Indicates whether the previous page was SSL-encrypted',
		'coldesc:Region' => 'Region where the visitor has been located',
		'coldesc:ScreenAvailHeight' => 'Screen height available to applications, in pixels',
		'coldesc:ScreenAvailWidth' => 'Screen width available to applications, in pixels',
		'coldesc:ScreenColors' => 'Screen color depth, in bits',
		'coldesc:ScreenHeight' => 'Total physical screen height, in pixels',
		'coldesc:ScreenWidth' => 'Total physical screen width, in pixels',
		'coldesc:SearchEngine' => 'Search engine that brought the visitor here',
		'coldesc:SearchImageUrl' => 'URL of the image found by the image search engine',
		'coldesc:SearchKeywords' => 'Search keywords that the visitor has entered in the search engine, if available',
		'coldesc:SearchResultPage' => 'Search result page number, if available',
		'coldesc:SessionDuration' => 'Duration of the entire visit, in seconds',
		'coldesc:SessionId' => 'Internal ID of the visit',
		'coldesc:SessionStartTime' => 'Time when the visit was started',
		'coldesc:SessionUpdateTime' => 'Time when the visit was last updated',
		'coldesc:Silverlight' => 'Indicates whether the browser supports the Silverlight plug-in',
		'coldesc:Ssl' => 'Indicates whether the page was requested SSL-encrypted',
		'coldesc:UrlHash' => 'URL hash of the viewed page',
		'coldesc:UrlPath' => 'URL path of the viewed page',
		'coldesc:UrlQuery' => 'URL query parameters of the viewed page',
		'coldesc:UtcOffset' => 'Offset of the visitor’s local time to UTC, in minutes',
		'coldesc:ViewportHeight' => 'Visible content height in the browser window, in pixels',
		'coldesc:ViewportWidth' => 'Visible content width in the browser window, in pixels',
		'coldesc:VisitorId' => 'Internal ID of the visitor',
		'coldesc:WindowsMedia' => 'Indicates whether the browser supports the Windows Media plug-in',
		
		'colgroup:visit' => 'Visit',
		'colgroup:visit/session' => 'Session',
		'colgroup:visit/source' => 'Source',
		'colgroup:visit/search' => 'Search',
		'colgroup:visit/location' => 'Location',
		'colgroup:page' => 'Page',
		'colgroup:page/pageview' => 'Pageview',
		'colgroup:page/address' => 'Address',
		'colgroup:page/action' => 'Action',
		'colgroup:client' => 'Client',
		'colgroup:client/browser' => 'Browser',
		'colgroup:client/config' => 'Configuration',
		'colgroup:client/plugins' => 'Plug-ins',
		'colgroup:client/screen' => 'Screen',
		'colgroup:vars' => 'Variables',
		'colgroup:vars/visitor' => 'Visitor',
		'colgroup:vars/session' => 'Session',
		'colgroup:vars/pageview' => 'Pageview',
		'colgroup:advanced' => 'Advanced',
		'colgroup:advanced/ids' => 'IDs',
		'colgroup:advanced/data' => 'Data',

		'op:between' => 'between',
		'op:between-and' => 'and',
		'op:startswith' => 'starts with',
		'op:endswith' => 'ends with',
		'op:contains' => 'contains',
		'op:inday' => 'in day',
		'op:inmonth' => 'in month',
		'op:inyear' => 'in year',
		'op:isnull' => 'is NULL',

		'contenttype:unknown' => 'unknown content type',

		'time:none' => 'no time',
		'time:never' => 'never',
		'time:now' => 'now',
		'time:combine' => ' and ',
		'time:pattern point past' => '{time} ago',
		'time:pattern point future' => 'in {time}',
		'time:pattern span past' => 'for {time}',
		'time:pattern span future' => 'for {time}',
		'time:pattern before past' => '{time} before',
		'time:pattern before future' => '{time} later',
		'time.1:years' => '{#} years',
		'time.1:years#1' => 'one year',
		'time.1:months' => '{#} months',
		'time.1:months#1' => 'one month',
		'time.1:days' => '{#} days',
		'time.1:days#1' => 'one day',
		'time.1:hours' => '{#} hours',
		'time.1:hours#1' => 'one hour',
		'time.1:minutes' => '{#} minutes',
		'time.1:minutes#1' => 'one minute',
		'time.1:seconds' => '{#} seconds',
		'time.1:seconds#1' => 'one second',
		'month:1' => 'Jan',
		'month:2' => 'Feb',
		'month:3' => 'Mar',
		'month:4' => 'Apr',
		'month:5' => 'May',
		'month:6' => 'Jun',
		'month:7' => 'Jul',
		'month:8' => 'Aug',
		'month:9' => 'Sep',
		'month:10' => 'Oct',
		'month:11' => 'Nov',
		'month:12' => 'Dec',
		'monthlong:1' => 'January',
		'monthlong:2' => 'February',
		'monthlong:3' => 'March',
		'monthlong:4' => 'April',
		'monthlong:5' => 'May',
		'monthlong:6' => 'June',
		'monthlong:7' => 'July',
		'monthlong:8' => 'August',
		'monthlong:9' => 'September',
		'monthlong:10' => 'October',
		'monthlong:11' => 'November',
		'monthlong:12' => 'December',
		'weekday:1' => 'Mon',
		'weekday:2' => 'Tue',
		'weekday:3' => 'Wed',
		'weekday:4' => 'Thu',
		'weekday:5' => 'Fri',
		'weekday:6' => 'Sat',
		'weekday:7' => 'Sun',
		'weekdaylong:1' => 'Monday',
		'weekdaylong:2' => 'Tuesday',
		'weekdaylong:3' => 'Wednesday',
		'weekdaylong:4' => 'Thursday',
		'weekdaylong:5' => 'Friday',
		'weekdaylong:6' => 'Saturday',
		'weekdaylong:7' => 'Sunday',

		'browser:edge' => 'Microsoft Edge',
		'browser:galeon' => 'Galeon',
		'browser:gecko/camino' => 'Camino (Gecko)',
		'browser:gecko/ff' => 'Firefox',
		'browser:gecko/kmeleon' => 'K-Meleon (Gecko)',
		'browser:gecko/nn' => 'Netscape',
		'browser:gecko/seamonkey' => 'SeaMonkey (Gecko)',
		'browser:icab' => 'iCab',
		'browser:ie/avant' => 'Avant (IE)',
		'browser:ie/ie' => 'Internet Explorer',
		'browser:ie/ie/compat' => 'Internet Explorer (compatibility mode)',
		'browser:ie/maxthon' => 'Maxthon (IE)',
		'browser:ie/mobile' => 'Mobile Internet Explorer',
		'browser:kindle' => 'Amazon Kindle',
		'browser:opera/mini' => 'Opera Mini',
		'browser:opera/mobile' => 'Opera Mobile',
		'browser:opera/opera' => 'Opera',
		'browser:webkit/chrome' => 'Chrome',
		'browser:webkit/chrome/chromium' => 'Chromium',
		'browser:webkit/chrome/frame' => 'Chrome Frame for Internet Explorer',
		'browser:webkit/konq' => 'Konqueror (Webkit)',
		'browser:webkit/mobile' => 'Mobile Safari',
		'browser:webkit/omniweb' => 'OmniWeb (Webkit)',
		'browser:webkit/safari' => 'Safari',

		'os:blackberry' => 'BlackBerry',
		'os:java/me' => 'Java Mobile',
		'os:java/me/midp' => 'Java MIDP',
		'os:mac' => 'MacOS',
		'os:mac/ipad' => 'iPad OS',
		'os:mac/iphone' => 'iPhone OS',
		'os:mac/x' => 'MacOS X',
		'os:os2' => 'OS/2',
		'os:palm' => 'PalmOS',
		'os:symbian' => 'Symbian',
		'os:unix' => 'Unix',
		'os:unix/freebsd' => 'FreeBSD',
		'os:unix/linux' => 'Linux',
		'os:unix/linux/android' => 'Android',
		'os:unix/sun' => 'Solaris',
		'os:webos' => 'webOS',
		'os:win' => 'Windows',
		'os:win/ce' => 'Windows CE',
		'os:win/ce/mobile' => 'Windows Mobile',
		'os:win/ce/phone' => 'Windows Phone',
		'os:win/me' => 'Windows ME',
		'os:win/nt' => 'Windows NT',
		'os:win/nt/arm' => 'Windows NT on ARM',
		'os:win/nt/2000' => 'Windows 2000',
		'os:win/nt/2003' => 'Windows Server 2003',
		'os:win/nt/7' => 'Windows 7',
		'os:win/nt/8' => 'Windows 8',
		'os:win/nt/8/arm' => 'Windows 8 RT',
		'os:win/nt/8.1' => 'Windows 8.1',
		'os:win/nt/8.1/arm' => 'Windows 8.1 RT',
		'os:win/nt/10' => 'Windows 10',
		'os:win/nt/vista' => 'Windows Vista',
		'os:win/nt/xp' => 'Windows XP',
		'os:win/phone' => 'Windows Phone',
		'os:win/phone/7' => 'Windows Phone 7',
		'os:win/phone/7.5' => 'Windows Phone 7.5',
		'os:win/phone/8.0' => 'Windows Phone 8',

		// Don't have country names translated anywhere as we're in the English locale.
		// English names will be provided by the GeoIP API if our dictionary doesn't contain them.
		'country:*' => false,

		// Source: http://www.statoids.com/ude.html (State name)
		'region:DE:Bayern' => 'Bavaria',
		'region:DE:Hessen' => 'Hesse',
		'region:DE:Niedersachsen' => 'Lower Saxony',
		'region:DE:Nordrhein-Westfalen' => 'North Rhine-Westphalia',
		'region:DE:Rheinland-Pfalz' => 'Rhineland-Palatinate',
		'region:DE:Mecklenburg-Vorpommern' => 'Mecklenburg-West Pomerania',
		'region:DE:Sachsen' => 'Saxony',
		'region:DE:Sachsen-Anhalt' => 'Saxony-Anhalt',
		'region:DE:Thuringen' => 'Thuringia',
		'region:DE:#nofallback' => true,

		// Don't have city names (with already English keys) translated anywhere as we're in the
		// English locale.
		'city:*' => false,

		// Source: http://www.sil.org/iso639-3/codes.asp?order=639_1&letter=%25
		'language:aa' => 'Afar',
		'language:ab' => 'Abkhazian',
		'language:ae' => 'Avestan',
		'language:af' => 'Afrikaans',
		'language:ak' => 'Akan',
		'language:am' => 'Amharic',
		'language:an' => 'Aragonese',
		'language:ar' => 'Arabic',
		'language:as' => 'Assamese',
		'language:av' => 'Avaric',
		'language:ay' => 'Aymara',
		'language:az' => 'Azerbaijani',
		'language:ba' => 'Bashkir',
		'language:be' => 'Belarusian',
		'language:bg' => 'Bulgarian',
		'language:bh' => 'Bihari languages',
		'language:bi' => 'Bislama',
		'language:bm' => 'Bambara',
		'language:bn' => 'Bengali',
		'language:bo' => 'Tibetan',
		'language:br' => 'Breton',
		'language:bs' => 'Bosnian',
		'language:ca' => 'Catalan',
		'language:ce' => 'Chechen',
		'language:ch' => 'Chamorro',
		'language:co' => 'Corsican',
		'language:cr' => 'Cree',
		'language:cs' => 'Czech',
		'language:cu' => 'Church Slavic',
		'language:cv' => 'Chuvash',
		'language:cy' => 'Welsh',
		'language:da' => 'Danish',
		'language:de' => 'German',
		'language:dv' => 'Dhivehi',
		'language:dz' => 'Dzongkha',
		'language:ee' => 'Ewe',
		'language:el' => 'Greek',
		'language:en' => 'English',
		'language:eo' => 'Esperanto',
		'language:es' => 'Spanish',
		'language:et' => 'Estonian',
		'language:eu' => 'Basque',
		'language:fa' => 'Persian',
		'language:ff' => 'Fulah',
		'language:fi' => 'Finnish',
		'language:fj' => 'Fijian',
		'language:fo' => 'Faroese',
		'language:fr' => 'French',
		'language:fy' => 'Western Frisian',
		'language:ga' => 'Irish',
		'language:gd' => 'Scottish Gaelic',
		'language:gl' => 'Galician',
		'language:gn' => 'Guarani',
		'language:gu' => 'Gujarati',
		'language:gv' => 'Manx',
		'language:ha' => 'Hausa',
		'language:he' => 'Hebrew',
		'language:hi' => 'Hindi',
		'language:ho' => 'Hiri Motu',
		'language:hr' => 'Croatian',
		'language:ht' => 'Haitian',
		'language:hu' => 'Hungarian',
		'language:hy' => 'Armenian',
		'language:hz' => 'Herero',
		'language:ia' => 'Interlingua',
		'language:id' => 'Indonesian',
		'language:ie' => 'Interlingue',
		'language:ig' => 'Igbo',
		'language:ii' => 'Sichuan Yi',
		'language:ik' => 'Inupiaq',
		'language:io' => 'Ido',
		'language:is' => 'Icelandic',
		'language:it' => 'Italian',
		'language:iu' => 'Inuktitut',
		'language:ja' => 'Japanese',
		'language:jv' => 'Javanese',
		'language:ka' => 'Georgian',
		'language:kg' => 'Kongo',
		'language:ki' => 'Kikuyu',
		'language:kj' => 'Kuanyama',
		'language:kk' => 'Kazakh',
		'language:kl' => 'Kalaallisut',
		'language:km' => 'Central Khmer',
		'language:kn' => 'Kannada',
		'language:ko' => 'Korean',
		'language:kr' => 'Kanuri',
		'language:ks' => 'Kashmiri',
		'language:ku' => 'Kurdish',
		'language:kv' => 'Komi',
		'language:kw' => 'Cornish',
		'language:ky' => 'Kirghiz',
		'language:la' => 'Latin',
		'language:lb' => 'Luxembourgish',
		'language:lg' => 'Ganda',
		'language:li' => 'Limburgan',
		'language:ln' => 'Lingala',
		'language:lo' => 'Lao',
		'language:lt' => 'Lithuanian',
		'language:lu' => 'Luba-Katanga',
		'language:lv' => 'Latvian',
		'language:mg' => 'Malagasy',
		'language:mh' => 'Marshallese',
		'language:mi' => 'Maori',
		'language:mk' => 'Macedonian',
		'language:ml' => 'Malayalam',
		'language:mn' => 'Mongolian',
		'language:mr' => 'Marathi',
		'language:ms' => 'Malay',
		'language:mt' => 'Maltese',
		'language:my' => 'Burmese',
		'language:na' => 'Nauru',
		'language:nb' => 'Norwegian Bokmål',
		'language:nd' => 'North Ndebele',
		'language:ne' => 'Nepali',
		'language:ng' => 'Ndonga',
		'language:nl' => 'Dutch',
		'language:nn' => 'Norwegian Nynorsk',
		'language:no' => 'Norwegian',
		'language:nr' => 'South Ndebele',
		'language:nv' => 'Navajo',
		'language:ny' => 'Nyanja',
		'language:oc' => 'Occitan',
		'language:oj' => 'Ojibwa',
		'language:om' => 'Oromo',
		'language:or' => 'Oriya',
		'language:os' => 'Ossetian',
		'language:pa' => 'Panjabi',
		'language:pi' => 'Pali',
		'language:pl' => 'Polish',
		'language:ps' => 'Pushto',
		'language:pt' => 'Portuguese',
		'language:qu' => 'Quechua',
		'language:rm' => 'Romansh',
		'language:rn' => 'Rundi',
		'language:ro' => 'Romanian',
		'language:ru' => 'Russian',
		'language:rw' => 'Kinyarwanda',
		'language:sa' => 'Sanskrit',
		'language:sc' => 'Sardinian',
		'language:sd' => 'Sindhi',
		'language:se' => 'Northern Sami',
		'language:sg' => 'Sango',
		'language:si' => 'Sinhala',
		'language:sk' => 'Slovak',
		'language:sl' => 'Slovenian',
		'language:sm' => 'Samoan',
		'language:sn' => 'Shona',
		'language:so' => 'Somali',
		'language:sq' => 'Albanian',
		'language:sr' => 'Serbian',
		'language:ss' => 'Swati',
		'language:st' => 'Southern Sotho',
		'language:su' => 'Sundanese',
		'language:sv' => 'Swedish',
		'language:sw' => 'Swahili',
		'language:ta' => 'Tamil',
		'language:te' => 'Telugu',
		'language:tg' => 'Tajik',
		'language:th' => 'Thai',
		'language:ti' => 'Tigrinya',
		'language:tk' => 'Turkmen',
		'language:tl' => 'Tagalog',
		'language:tn' => 'Tswana',
		'language:to' => 'Tonga',
		'language:tr' => 'Turkish',
		'language:ts' => 'Tsonga',
		'language:tt' => 'Tatar',
		'language:tw' => 'Twi',
		'language:ty' => 'Tahitian',
		'language:ug' => 'Uighur',
		'language:uk' => 'Ukrainian',
		'language:ur' => 'Urdu',
		'language:uz' => 'Uzbek',
		'language:ve' => 'Venda',
		'language:vi' => 'Vietnamese',
		'language:vo' => 'Volapük',
		'language:wa' => 'Walloon',
		'language:wo' => 'Wolof',
		'language:xh' => 'Xhosa',
		'language:yi' => 'Yiddish',
		'language:yo' => 'Yoruba',
		'language:za' => 'Zhuang',
		'language:zh' => 'Chinese',
		'language:zu' => 'Zulu',
		);

	protected function FormatNumber($number, $decimals, $html, $trim)
	{
		$str = number_format($number, $decimals, '.', ',');
		if ($trim && strpos($str, '.') !== false)
		{
			$str = rtrim($str, '0');
			$str = rtrim($str, '.');
		}
		return $str;
	}

	protected function DoParseNumber($str, $recoveryValue)
	{
		$str = str_replace(',', '', $str);
		$str = str_replace(' ', '', $str);
		if (!is_numeric($str))
		{
			if (isset($recoveryValue))
				return $recoveryValue;
			throw new InvalidArgumentException('Invalid numeric value format.');
		}

		if (strpos($str, '.') !== false)
			return floatval($str);
		else
			return intval($str);
	}

	protected function FormatOrdinalNumber($number, $html)
	{
		if ($number <= 0) return $num;
		// TODO: Except all *teen numbers %100, they get "th"
		if ($number % 10 == 1) return $number . ($html ? '<sup>' : '') . 'st' . ($html ? '</sup>' : '');
		if ($number % 10 == 2) return $number . ($html ? '<sup>' : '') . 'nd' . ($html ? '</sup>' : '');
		if ($number % 10 == 3) return $number . ($html ? '<sup>' : '') . 'rd' . ($html ? '</sup>' : '');
		return $number . ($html ? '<sup>' : '') . 'th' . ($html ? '</sup>' : '');
	}

	protected function FormatTime($datetime, $details, $html)
	{
		$sp = "\xC2\xA0";   // "\xC2\xA0" = utf8_encode("\xA0")
		$lsp = "\xE2\x80\x87";   // UTF-8 for U+2007 (Figure Space, no break)

		$str = '';

		if ($details & UnbTimeFormat::Weekday)   // Mon
		{
			$str .= (strlen($str) ? $sp : '') .
				UnbLocale::Translate('weekday:' . $datetime->format('N')) .
				($details & ~UnbTimeFormat::Weekday ? ',' : '');
		}
		else if ($details & UnbTimeFormat::WeekdayLong)   // Monday
		{
			$str .= (strlen($str) ? $sp : '') .
				UnbLocale::Translate('weekdaylong:' . $datetime->format('N')) .
				($details & ~UnbTimeFormat::WeekdayLong ? ',' : '');
		}

		if ($details & UnbTimeFormat::Date)   // 01/01/2000
		{
			$str .= (strlen($str) ? $sp : '') .
				$datetime->format('m/d/Y');
			$haveDate = true;
		}
		else if ($details & UnbTimeFormat::DateLong)   // January 1, 2000
		{
			$str .= (strlen($str) ? $sp : '') .
				UnbLocale::Translate('monthlong:' . $datetime->format('n')) . $sp .
				$datetime->format('j') . ',' . $sp .
				$datetime->format('Y');
			$haveDate = true;
		}

		if ($details & UnbTimeFormat::TimeSec)   // 12:15:00 pm
		{
			$str .= (strlen($str) ? ($haveDate && $html ? $lsp : $sp) : '') .
				$datetime->format('g:i:s a');
		}
		else if ($details & UnbTimeFormat::Time)   // 12:15 pm
		{
			$str .= (strlen($str) ? ($haveDate && $html ? $lsp : $sp) : '') .
				$datetime->format('g:i a');
		}

		if ($details & UnbTimeFormat::TimeZone)   // UTC
		{
			$str .= (strlen($str) ? $sp : '') .
				$datetime->format('T');
		}

		return $str;
	}

	protected function FormatRelativeTime($diff, $context, $html)
	{
		switch ($context)
		{
			case UnbTimeContext::Point:
				if ($diff->invert)   // 2 years ago
					$grammar = 1;
				else   // in 2 years
					$grammar = 1;
				break;

			case UnbTimeContext::Span:
				if ($diff->invert)   // for 2 years
					$grammar = 1;
				else   // for 2 years
					$grammar = 1;
				break;

			case UnbTimeContext::Before:
				if ($diff->invert)   // 2 years before
					$grammar = 1;
				else   // 2 years later
					$grammar = 1;
				break;
		}

		$parts = array();
		if ($diff->y && count($parts) < 2)
			$parts[] = UnbLocale::NoBreak(UnbLocale::Translate('time.' . $grammar . ':years', $diff->y));
		if ($diff->m && count($parts) < 2)
			$parts[] = UnbLocale::NoBreak(UnbLocale::Translate('time.' . $grammar . ':months', $diff->m));
		if ($diff->d && count($parts) < 2)
			$parts[] = UnbLocale::NoBreak(UnbLocale::Translate('time.' . $grammar . ':days', $diff->d));
		if ($diff->h && count($parts) < 2)
			$parts[] = UnbLocale::NoBreak(UnbLocale::Translate('time.' . $grammar . ':hours', $diff->h));
		if ($diff->i && count($parts) < 2)
			$parts[] = UnbLocale::NoBreak(UnbLocale::Translate('time.' . $grammar . ':minutes', $diff->i));
		if ($diff->s && count($parts) < 2)
			$parts[] = UnbLocale::NoBreak(UnbLocale::Translate('time.' . $grammar . ':seconds', $diff->s));

		$str = '';
		foreach ($parts as $part)
		{
			$str .= (strlen($str) ? UnbLocale::Translate('time:combine') : '') .
				$part;
		}

		switch ($context)
		{
			case UnbTimeContext::Point:
				if ($diff->invert)   // 2 years ago
					$str = self::Translate('time:pattern point past', 'time', $str);
				else   // in 2 years
					$str = self::Translate('time:pattern point future', 'time', $str);
				break;

			case UnbTimeContext::Span:
				if ($diff->invert)   // for 2 years
					$str = self::Translate('time:pattern span past', 'time', $str);
				else   // for 2 years
					$str = self::Translate('time:pattern span future', 'time', $str);
				break;

			case UnbTimeContext::Before:
				if ($diff->invert)   // 2 years before
					$str = self::Translate('time:pattern before past', 'time', $str);
				else   // 2 years later
					$str = self::Translate('time:pattern before future', 'time', $str);
				break;
		}
		return $str;
	}

}

// Automatically register this locale
UnbLocale::Register(new UnbLocale_en_US());

?>
